<?php
	
	include("../../config.php");
	include($baseURL."header.php");
	include($baseURL."css/design.php");

	if (session_status() == PHP_SESSION_NONE) {
		session_start();
	}
	
	$gap = $_GET['gap'];
	
	$from = ($_GET['from']);
	$to = ($_GET['to']);
	
	$memoryIncrease = trim($_GET['memory']);
	
	$firstTimestamp = strtotime($_GET['from']." 00:00");
	$lastTimestamp = strtotime($_GET['to']." 23:59:59");
	
	if($memoryIncrease == 1){
		$splitLength = $lastTimestamp-$firstTimestamp;
		$splitInterval = $splitLength + 1;
	}
	else{
		$splitLength = $lastTimestamp-$firstTimestamp;
		$splitInterval = $splitLength/$memoryIncrease;
	}
	
	
	$rateT = $_GET['rateT'];
	$rateA = $_GET['rateA'];
	$rateH = $_GET['rateH'];
	$rateP = $_GET['rateP'];
	$rateR = $_GET['rateR'];
	
	for($i=1;$i<13;$i++){
		${"minT".$i} = $_GET['minT'.$i];
		${"maxT".$i} = $_GET['maxT'.$i];
		${"minH".$i} = $_GET['minH'.$i];
		${"maxH".$i} = $_GET['maxH'.$i];
		${"minP".$i} = $_GET['minP'.$i];
		${"maxP".$i} = $_GET['maxP'.$i];
		${"minA".$i} = $_GET['minA'.$i];
		${"maxA".$i} = $_GET['maxA'.$i];
		${"maxW".$i} = $_GET['maxW'.$i];
		${"maxG".$i} = $_GET['maxG'.$i];
		${"maxR".$i} = $_GET['maxR'.$i];
	}
	
	// prevent SQL injection
	$checkFrom = strtotime($from);
	if(date('Y',$checkFrom)<1900 || date('Y',$checkFrom)>2100){
		die();		
	}
	$checkTo = strtotime($to);
	if(date('Y',$checkTo)<1900 || date('Y',$checkTo)>2100){
		die();		
	}
	
	$gapLength = 0;
	$totalValues = 0;
	$totalLength = 0;
	$totalSpikes = 0;
	$totalOutliers = 0;
	$totalNonsense = 0;
	
	$thisInterval = $firstTimestamp;
	$nextInterval = $thisInterval + $splitInterval;
	
	while($thisInterval<=$lastTimestamp){
		$fromInterval = date('Y-m-d H:i:s',$thisInterval);
		$toInterval = date('Y-m-d H:i:s',$nextInterval);
	
		$span = "WHERE DateTime >= '$fromInterval' AND DateTime <= '$toInterval'";
		
		$x = mysqli_query($con,
			"
			SELECT DateTime, Month(DateTime), T, H, P, R, A, W, G, B
			FROM alldata 
			$span
			ORDER BY DateTime
			"
		);
		while($row = mysqli_fetch_array($x)){
			$row['A'] = $row['A'] * 1;
			$row['T'] = $row['T'] * 1;
			$row['H'] = $row['H'] * 1;
			$row['P'] = $row['P'] * 1;
			$row['W'] = $row['W'] * 1;
			$row['G'] = $row['G'] * 1;
			$row['B'] = $row['B'] * 1;
			$row['R'] = $row['R'] * 1;
			$totalValues++;
			if(!isset($previous)){
				$previous = strtotime($row['DateTime']);
				$current = strtotime($row['DateTime']);
				$previousT = $row['T'];
				$previousA = $row['A'];
				$previousH = $row['H'];
				$previousP = $row['P'];
				$previousR = $row['R'];
				$previousW = $row['W'];
				$previousG = $row['G'];
			}
			else{
				$current = strtotime($row['DateTime']);
				$currentT = $row['T'];
				$currentA = $row['A'];
				$currentH = $row['H'];
				$currentP = $row['P'];
				$currentR = $row['R'];
				$currentW = $row['W'];
				$currentG = $row['G'];
				$currentInterval = ($current - $previous)/60;
				$currentTRate = abs($currentT - $previousT) / (($current - $previous)) * 600;
				$currentARate = abs($currentA - $previousA) / (($current - $previous)) * 600;
				$currentHRate = abs($currentH - $previousH) / (($current - $previous)) * 600;
				$currentPRate = abs($currentP - $previousP) / (($current - $previous)) * 600;
				$currentRRate = ($currentR - $previousR) / (($current - $previous)) * 600;
				
				if($currentInterval >= $gap){
					$gaps[] = array(($previous),strtotime($row['DateTime']));
					$gapLength += ($current - $previous);
				}
				$totalLength += ($current - $previous);
				if($currentTRate >= $rateT){
					$spikesT[] = array(($previous),strtotime($row['DateTime']),$previousT, $currentT);
					$totalSpikes++;
				}
				if($currentARate >= $rateA){
					$spikesA[] = array(($previous),strtotime($row['DateTime']),$previousA, $currentA);
					$totalSpikes++;
				}
				if($currentHRate >= $rateH){
					$spikesH[] = array(($previous),strtotime($row['DateTime']),$previousH, $currentH);
					$totalSpikes++;
				}
				if($currentPRate >= $rateP){
					$spikesP[] = array(($previous),strtotime($row['DateTime']),$previousP, $currentP);
					$totalSpikes++;
				}
				if($currentRRate >= $rateR){
					$spikesR[] = array(($previous),strtotime($row['DateTime']),$previousR, $currentR);
					$totalSpikes++;
				}
				$previous = $current;
				$previousT = $currentT;
				$previousA = $currentA;
				$previousH = $currentH;
				$previousP = $currentP;
				$previousR = $currentR;
			}
			for($a=1;$a<13;$a++){
				if($row['Month(DateTime)']==$a){
					if($row['T']<=${"minT".$a}){
						$outliersT[] = array(strtotime($row['DateTime']),$row['T']);
						$totalOutliers++;
					}
					if($row['T']>=${"maxT".$a}){
						$outliersT[] = array(strtotime($row['DateTime']),$row['T']);
						$totalOutliers++;
					}
					if($row['A']<=${"minA".$a}){
						$outliersA[] = array(strtotime($row['DateTime']),$row['A']);
						$totalOutliers++;
					}
					if($row['A']>=${"maxA".$a}){
						$outliersA[] = array(strtotime($row['DateTime']),$row['A']);
						$totalOutliers++;
					}
					if($row['H']<=${"minH".$a}){
						$outliersH[] = array(strtotime($row['DateTime']),$row['H']);
						$totalOutliers++;
					}
					if($row['H']>=${"maxH".$a}){
						$outliersH[] = array(strtotime($row['DateTime']),$row['H']);
						$totalOutliers++;
					}
					if($row['P']<=${"minP".$a}){
						$outliersP[] = array(strtotime($row['DateTime']),$row['P']);
						$totalOutliers++;
					}
					if($row['P']>=${"maxP".$a}){
						$outliersP[] = array(strtotime($row['DateTime']),$row['P']);
						$totalOutliers++;
					}
					if($row['W']>=${"maxW".$a}){
						$outliersW[] = array(strtotime($row['DateTime']),$row['W']);
						$totalOutliers++;
					}
					if($row['G']>=${"maxG".$a}){
						$outliersG[] = array(strtotime($row['DateTime']),$row['G']);
						$totalOutliers++;
					}
					if($row['R']>=${"maxR".$a}){
						$outliersR[] = array(strtotime($row['DateTime']),$row['R']);
						$totalOutliers++;
					}
				}
			}
			if($row['W']<0){
				$nonSense[] = array(strtotime($row['DateTime']),'wind',$row['W']);
				$totalNonsense++;
			}
			if($row['G']<0){
				$nonSense[] = array(strtotime($row['DateTime']),'gust',$row['G']);
				$totalNonsense++;
			}
			if($row['B']<0){
				$nonSense[] = array(strtotime($row['DateTime']),'wind direction',$row['B']);
				$totalNonsense++;
			}
			if($row['B']>360){
				$nonSense[] = array(strtotime($row['DateTime']),'wind direction',$row['B']);
				$totalNonsense++;
			}
			if($row['R']<0){
				$nonSense[] = array(strtotime($row['DateTime']),'precipitation',$row['R']);
				$totalNonsense++;
			}
			if($row['H']<0){
				$nonSense[] = array(strtotime($row['DateTime']),'humidity',$row['H']);
				$totalNonsense++;
			}
			if($row['H']>100){
				$nonSense[] = array(strtotime($row['DateTime']),'humidity',$row['H']);
				$totalNonsense++;
			}
			if($row['P']<0){
				$nonSense[] = array(strtotime($row['DateTime']),'pressure',$row['P']);
				$totalNonsense++;
			}
			if($row['P']>1100){
				$nonSense[] = array(strtotime($row['DateTime']),'pressure',$row['P']);
				$totalNonsense++;
			}
			if($row['T']<-100){
				$nonSense[] = array(strtotime($row['DateTime']),'temp',$row['T']);
				$totalNonsense++;
			}
			if($row['T']>150){
				$nonSense[] = array(strtotime($row['DateTime']),'temp',$row['T']);
				$totalNonsense++;
			}
			if($row['A']<-100){
				$nonSense[] = array(strtotime($row['DateTime']),'apparent',$row['A']);
				$totalNonsense++;
			}
			if($row['A']>150){
				$nonSense[] = array(strtotime($row['DateTime']),'apparent',$row['A']);
				$totalNonsense++;
			}
		}
		
		$thisInterval = $nextInterval;
		$nextInterval = $nextInterval + $splitInterval;
	}
	
	$gapRatio = $gapLength/$totalLength * 100;
	
	function dateDiff($time1, $time2, $precision = 6) {
		if (!is_int($time1)) {
		  $time1 = strtotime($time1);
		}
		if (!is_int($time2)) {
		  $time2 = strtotime($time2);
		}
		if ($time1 > $time2) {
		  $ttime = $time1;
		  $time1 = $time2;
		  $time2 = $ttime;
		}
		$intervals = array('year','month','day','hour','minute','second');
		$diffs = array();
		foreach ($intervals as $interval) {
		  $ttime = strtotime('+1 ' . $interval, $time1);
		  $add = 1;
		  $looped = 0;
		  while ($time2 >= $ttime) {
			$add++;
			$ttime = strtotime("+" . $add . " " . $interval, $time1);
			$looped++;
		  }
		  $time1 = strtotime("+" . $looped . " " . $interval, $time1);
		  $diffs[$interval] = $looped;
		}
		$count = 0;
		$times = array();
		foreach ($diffs as $interval => $value) {
		  if ($count >= $precision) {
			break;
		  }
		  if ($value > 0) {
			$times[] = $value . " " . $interval;
			$count++;
		  }
		}
		$result = implode(" ", $times);
		$result = str_replace("year","y",$result);
		$result = str_replace("month","m",$result);
		$result = str_replace("day","d",$result);
		$result = str_replace("hour","h",$result);
		$result = str_replace("minute","min",$result);
		$result = str_replace("second","s",$result);
		return $result;
	}

	if($_SESSION['user']=="admin"){
		$admin = true;
	}
	else{
		$admin = false;
	}
	
	?>
	<style>
		.dataCheckGraph{
			width:98%;
			margin:0 auto;
			height:300px;
			border-radius:5px;
			border:1px solid #aaaaaa;
			background:#444444;
			margin-bottom:25px;
		}
		.editIcon{
			width: 20px;
			opacity: 0.8;
			cursor: pointer;
		}
		.editIcon:hover{
			opacity: 1;
		}
	</style>
	<br>
	<br>
	<input id="scrollSummary" type="button" class="button2" value="<?php echo lang('summary','c')?>">
	<input id="scrollGraph" type="button" class="button2" value="<?php echo lang('graphs','c')?>">
	<input id="scrollTable" type="button" class="button2" value="<?php echo lang('tables','c')?>">
	<br><br>
	<span id="titleSummary"></span>
	<div class="sectionDiv">
		<h2><?php echo lang('summary','c')?></h2>
		<br><br>
		<table class="table" style="width:98%;margin:0 auto">
			<tr>
				<td>
					<?php echo lang('interval length','c')?>
				</td>
				<td>
					<?php
						echo dateDiff($firstTimestamp,$lastTimestamp+1);
					?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo lang('total gaps','c')?>
				</td>
				<td>
					<?php
						if(isset($gaps)){
							echo count($gaps);
						}
						else{
							echo "0";
						}
					?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo lang('total gap length','c')?>
				</td>
				<td>
					<?php
						if(isset($gaps)){
							echo dateDiff($gapLength,0);
						}
						else{
							echo lang('no gaps','c');
						}
					?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo lang('gap ratio','c')?>
				</td>
				<td>
					<?php
						if(isset($gaps)){
							echo number_format($gapRatio,3,".","")." %";
						}
						else{
							echo "0.000 %";
						}
					?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo lang('total spikes','c')?>
				</td>
				<td>
					<?php
						echo $totalSpikes."<br>(".number_format(($totalSpikes/$totalValues*100),3,".","")." %)";
					?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo lang('total outliers','c')?>
				</td>
				<td>
					<?php
						echo $totalOutliers."<br>(".number_format(($totalOutliers/$totalValues*100),3,".","")." %)";
					?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo lang('total nonsense values','c')?>
				</td>
				<td>
					<?php
						echo $totalNonsense."<br>(".number_format(($totalNonsense/$totalValues*100),3,".","")." %)";
					?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo lang('potentially problematic values','c')?>
				</td>
				<td>
					<?php
						echo ($totalSpikes + $totalOutliers + $totalNonsense)."<br>(".number_format((($totalSpikes + $totalOutliers + $totalNonsense)/$totalValues*100),3,".","")." %)";
					?>
				</td>
			</tr>
		</table>
	</div>
	<br>
	<span id="titleGraphs"></span>
	<div class="sectionDiv">
		<h2><?php echo lang('graphs','c')?></h2>
		<br><br>
		<h3><?php echo lang('gaps','c')." ".lang('and','l')." ".lang('spikes','c')?></h3>
		<br><br>
		<div id="dataCheckGraph" style="width:98%;margin:0 auto;height:600px;border-radius:10px;border:1px solid #aaaaaa;background:#444444"></div>
		<br>
		<h3><?php echo lang('outliers','c')?></h3>
		<br><br>
		<div id="dataCheckGraphTA" class="dataCheckGraph"></div>
		<div id="dataCheckGraphH" class="dataCheckGraph"></div>
		<div id="dataCheckGraphP" class="dataCheckGraph"></div>
		<div id="dataCheckGraphWG" class="dataCheckGraph"></div>
		<div id="dataCheckGraphR" class="dataCheckGraph"></div>
		<br>
		<h3><?php echo lang('nonsense values','c')?></h3>
		<br><br>
		<div id="dataCheckGraphNonsense" style="width:98%;margin:0 auto;height:400px;border-radius:10px;border:1px solid #aaaaaa;background:#444444"></div>
	</div>
	<br>
	<span id="titleTables"></span>
	<div class="sectionDiv">
		<h2><?php echo lang('tables','c')?></h2>
		<br><br>
		<h3><?php echo lang('gaps','c')?></h3>
		<br><br>
		<?php 
			if(isset($gaps)){
		?>	
			<table style="width:98%;margin:0 auto" class="table">
				<thead>
					<tr>
						<th rowspan="2">
							<?php echo lang('from','c')?>
						</th>
						<th rowspan="2">
							<?php echo lang('to','c')?>
						</th>
						<th colspan="2">
							<?php echo lang('duration','c')?>
						</th>
					</tr>
					<tr>
						<th>
						</th>
						<th>
							(s)<br><img src="<?php echo $pageURL.$path?>icons/sort.png" class="sort" alt=''>
						</th>
					</tr>
				</thead>
				<tbody>
				<?php
					for($i=0;$i<count($gaps);$i++){
				?>
						<tr>
							<td>
								<?php echo date($dateTimeFormat,$gaps[$i][0])?>
							</td>
							<td>
								<?php echo date($dateTimeFormat,$gaps[$i][1])?>
							</td>
							<td>
								<?php echo dateDiff($gaps[$i][0],$gaps[$i][1])?>
							</td>
							<td>
								<?php echo ($gaps[$i][1] - $gaps[$i][0])?>
							</td>
						</tr>
				<?php
					}
				?>
				</tbody>
			</table>
		<?php
			}
			if(!isset($gaps)){
				echo "<br>".lang("no gaps",'c').".";
			}
		?>
		<br><br>
		<h3><?php echo lang('spikes','c')?></h3>
		<br><br>
		<h3><img src="<?php echo $pageURL.$path?>icons/temp.png" class="parameterCheckIcon"></h3>
		<br>
		<?php 
			if(isset($spikesT)){
		?>	
			<table style="width:98%;margin:0 auto" class="table">
				<thead>
					<tr>
						<th>
							<?php echo lang('from','c');?>
						</th>
						<th>
							<?php echo lang('to','c');?>
						</th>
						<th>
							<img src="<?php echo $pageURL.$path?>icons/temp.png" class="parameterCheckIcon">
						</th>
						<th>
							<img src="icons/deviation.png" style="width:30px" ><br><img src="<?php echo $pageURL.$path?>icons/sort.png" class="sort" alt=''>
						</th>
						<?php 
							if($admin){
						?>
								<th>
								</th>
						<?php 
							}
						?>
					</tr>
				</thead>
				<tbody>
				<?php
					for($i=0;$i<count($spikesT);$i++){
				?>
						<tr>
							<td>
								<?php echo date($dateTimeFormat,$spikesT[$i][0])?>
							</td>
							<td>
								<?php echo date($dateTimeFormat,$spikesT[$i][1])?>
							</td>
							<td>
								<?php echo $spikesT[$i][2];?>&nbsp;°<?php echo $dataTempUnits?>&nbsp;&#8702;&nbsp;<?php echo $spikesT[$i][3];?>&nbsp;°<?php echo $dataTempUnits?>
							</td>
							<td>
								<?php echo $spikesT[$i][3] - $spikesT[$i][2];?>
							</td>
							<?php 
								if($admin){
							?>
									<td>
										<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$spikesT[$i][0]);?>)">
									</td>
							<?php 	
								}
							?>
						</tr>
				<?php
					}
				?>
				</tbody>
			</table>
		<?php
			}
			if(!isset($spikesT)){
				echo "<br>".lang("no spikes in the selected period",'c').".";
			}
		?>
		<br><br>
		<h3><img src="<?php echo $pageURL.$path?>icons/apparent.png" class="parameterCheckIcon"></h3>
		<br>
		<?php 
			if(isset($spikesA)){
		?>	
			<table style="width:98%;margin:0 auto" class="table">
				<thead>
					<tr>
						<th>
							<?php echo lang('from','c');?>
						</th>
						<th>
							<?php echo lang('to','c');?>
						</th>
						<th>
							<img src="<?php echo $pageURL.$path?>icons/apparent.png" class="parameterCheckIcon">
						</th>
						<th>
							<img src="icons/deviation.png" style="width:30px" ><br><img src="<?php echo $pageURL.$path?>icons/sort.png" class="sort" alt=''>
						</th>
						<?php 
							if($admin){
						?>
								<th>
								</th>
						<?php 
							}
						?>
					</tr>
				</thead>
				<tbody>
				<?php
					for($i=0;$i<count($spikesA);$i++){
				?>
						<tr>
							<td>
								<?php echo date($dateTimeFormat,$spikesA[$i][0])?>
							</td>
							<td>
								<?php echo date($dateTimeFormat,$spikesA[$i][1])?>
							</td>
							<td>
								<?php echo $spikesA[$i][2];?>&nbsp;°<?php echo $dataTempUnits?>&nbsp;&#8702;&nbsp;<?php echo $spikesA[$i][3];?>&nbsp;°<?php echo $dataTempUnits?>
							</td>
							<td>
								<?php echo $spikesA[$i][3] - $spikesA[$i][2];?>
							</td>
							<?php 
								if($admin){
							?>
									<td>
										<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$spikesA[$i][0]);?>)">
									</td>
							<?php 
								}
							?>
						</tr>
				<?php
					}
				?>
				</tbody>
			</table>
		<?php
			}
			if(!isset($spikesA)){
				echo "<br>".lang("no spikes in the selected period",'c').".";
			}
		?>
		<br><br>
		<h3><img src="<?php echo $pageURL.$path?>icons/humidity.png" class="parameterCheckIcon"></h3>
		<br>
		<?php 
			if(isset($spikesH)){
		?>	
			<table style="width:98%;margin:0 auto" class="table">
				<thead>
					<tr>
						<th>
							<?php echo lang('from','c');?>
						</th>
						<th>
							<?php echo lang('to','c');?>
						</th>
						<th>
							<img src="<?php echo $pageURL.$path?>icons/humidity.png" class="parameterCheckIcon">
						</th>
						<th>
							<img src="icons/deviation.png" style="width:30px" ><br><img src="<?php echo $pageURL.$path?>icons/sort.png" class="sort" alt=''>
						</th>
						<?php 
							if($admin){
						?>
								<th>
								</th>
						<?php 
							}
						?>
					</tr>
				</thead>
				<tbody>
				<?php
					for($i=0;$i<count($spikesH);$i++){
				?>
						<tr>
							<td>
								<?php echo date($dateTimeFormat,$spikesH[$i][0])?>
							</td>
							<td>
								<?php echo date($dateTimeFormat,$spikesH[$i][1])?>
							</td>
							<td>
								<?php echo $spikesH[$i][2];?>&nbsp;%&nbsp;&#8702;&nbsp;<?php echo $spikesH[$i][3];?>&nbsp;%
							</td>
							<td>
								<?php echo $spikesH[$i][3] - $spikesH[$i][2];?>
							</td>
							<?php 
								if($admin){
							?>
									<td>
										<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$spikesH[$i][0]);?>)">
									</td>
							<?php 
								}
							?>
						</tr>
				<?php
					}
				?>
				</tbody>
			</table>
		<?php
			}
			if(!isset($spikesH)){
				echo "<br>".lang("no spikes in the selected period",'c').".";
			}
		?>
		<br><br>
		<h3><img src="<?php echo $pageURL.$path?>icons/pressure.png" class="parameterCheckIcon"></h3>
		<br>
		<?php 
			if(isset($spikesP)){
		?>	
			<table style="width:98%;margin:0 auto" class="table">
				<thead>
					<tr>
						<th>
							<?php echo lang('from','c');?>
						</th>
						<th>
							<?php echo lang('to','c');?>
						</th>
						<th>
							<img src="<?php echo $pageURL.$path?>icons/pressure.png" class="parameterCheckIcon">
						</th>
						<th>
							<img src="icons/deviation.png" style="width:30px" ><br><img src="<?php echo $pageURL.$path?>icons/sort.png" class="sort" alt=''>
						</th>
						<?php 
							if($admin){
						?>
								<th>
								</th>
						<?php 
							}
						?>
					</tr>
				</thead>
				<tbody>
				<?php
					for($i=0;$i<count($spikesP);$i++){
				?>
						<tr>
							<td>
								<?php echo date($dateTimeFormat,$spikesP[$i][0])?>
							</td>
							<td>
								<?php echo date($dateTimeFormat,$spikesP[$i][1])?>
							</td>
							<td>
								<?php echo $spikesP[$i][2];?>&nbsp;<?php echo $dataPressUnits?>&nbsp;&#8702;&nbsp;<?php echo $spikesP[$i][3];?>&nbsp;<?php echo $dataPressUnits?>
							</td>
							<td>
								<?php echo $spikesP[$i][3] - $spikesP[$i][2];?>
							</td>
							<?php 
								if($admin){
							?>
								<td>
									<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$spikesP[$i][0]);?>)">
								</td>
							<?php 
								}
							?>
						</tr>
				<?php
					}
				?>
				</tbody>
			</table>
		<?php
			}
			if(!isset($spikesP)){
				echo "<br>".lang("no spikes in the selected period",'c').".";
			}
		?>
		<br><br>
		<h3><img src="<?php echo $pageURL.$path?>icons/rain.png" class="parameterCheckIcon"></h3>
		<br>
		<?php 
			if(isset($spikesR)){
		?>	
			<table style="width:98%;margin:0 auto" class="table">
				<thead>
					<tr>
						<th>
							<?php echo lang('from','c');?>
						</th>
						<th>
							<?php echo lang('to','c');?>
						</th>
						<th>
							<img src="<?php echo $pageURL.$path?>icons/rain.png" class="parameterCheckIcon">
						</th>
						<th>
							<img src="icons/deviation.png" style="width:30px" ><br><img src="<?php echo $pageURL.$path?>icons/sort.png" class="sort" alt=''>
						</th>
						<?php 
							if($admin){
						?>
								<th>
								</th>
						<?php 
							}
						?>
					</tr>
				</thead>
				<tbody>
				<?php
					for($i=0;$i<count($spikesR);$i++){
				?>
						<tr>
							<td>
								<?php echo date($dateTimeFormat,$spikesR[$i][0])?>
							</td>
							<td>
								<?php echo date($dateTimeFormat,$spikesR[$i][1])?>
							</td>
							<td>
								<?php echo $spikesR[$i][2];?>&nbsp;<?php echo $dataRainUnits?>&nbsp;&#8702;&nbsp;<?php echo $spikesR[$i][3];?>&nbsp;°<?php echo $dataRainUnits?>
							</td>
							<td>
								<?php echo $spikesR[$i][3] - $spikesR[$i][2];?>
							</td>
							<?php 
								if($admin){
							?>
									<td>
										<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$spikesR[$i][0]);?>)">
									</td>
							<?php 
								}
							?>	
						</tr>
				<?php
					}
				?>
				</tbody>
			</table>
		<?php
			}
			if(!isset($spikesR)){
				echo "<br>".lang("no spikes in the selected period",'c').".";
			}
		?>
		<br><br>
		<h3><?php echo lang('outliers','c')?></h3>
		<br><br>
		<table style="width:98%;margin:0 auto">
			<tr>
				<td style="width:14%;vertical-align:top">
					<br><br>
					<img src="<?php echo $pageURL.$path?>icons/temp.png" class="parameterCheckIcon">
					<?php 
						if(isset($outliersT)){
					?>
						<table style="width:98%;margin:0 auto" class="table">
							<thead>
								<tr>
									<th style="width:70%">
										<img src="<?php echo $pageURL.$path?>icons/time.png" class="parameterCheckIcon" alt=''>
									</th>
									<th>
									</th>
									<?php 
										if($admin){
									?>
											<th>
											</th>
									<?php 
										}
									?>
								</tr>
							</thead>
							<tbody>
							<?php
								for($i=0;$i<count($outliersT);$i++){
							?>
									<tr>
										<td>
											<?php echo date($dateFormat,$outliersT[$i][0])?><br><?php echo date($timeFormat,$outliersT[$i][0])?>
										</td>
										<td>
											<?php echo $outliersT[$i][1]?> °<?php echo $dataTempUnits?>
										</td>
										<?php 
											if($admin){
										?>
												<td>
													<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$outliersT[$i][0]);?>)">
												</td>
										<?php 
											}
										?>
									</tr>
							<?php
								}
							?>
							</tbody>
						</table>
					<?php
						}
						if(!isset($outliersT)){
							echo "<br><br>".lang("no outliers",'c').".";
						}
					?>
				</td>
				<td style="width:14%;vertical-align:top">
					<br><br>
					<img src="<?php echo $pageURL.$path?>icons/apparent.png" class="parameterCheckIcon">
					<?php 
						if(isset($outliersA)){
					?>
						<table style="width:98%;margin:0 auto" class="table">
							<thead>
								<tr>
									<th style="width:70%">
										<img src="<?php echo $pageURL.$path?>icons/time.png" class="parameterCheckIcon" alt=''>
									</th>
									<th>
									</th>
									<?php 
										if($admin){
									?>
											<th>
											</th>
									<?php 
										}
									?>
								</tr>
							</thead>
							<tbody>
							<?php
								for($i=0;$i<count($outliersA);$i++){
							?>
									<tr>
										<td>
											<?php echo date($dateFormat,$outliersA[$i][0])?><br><?php echo date($timeFormat,$outliersA[$i][0])?>
										</td>
										<td>
											<?php echo $outliersA[$i][1]?> °<?php echo $dataTempUnits?>
										</td>
										<?php 
											if($admin){
										?>
												<td>
													<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$outliersA[$i][0]);?>)">
												</td>
										<?php 
											}
										?>
									</tr>
							<?php
								}
							?>
							</tbody>
						</table>
					<?php
						}
						if(!isset($outliersA)){
							echo "<br><br>".lang("no outliers",'c').".";
						}
					?>
				</td>
				<td style="width:14%;vertical-align:top">
					<br><br>
					<img src="<?php echo $pageURL.$path?>icons/humidity.png" class="parameterCheckIcon">
					<?php 
						if(isset($outliersH)){
					?>
						<table style="width:98%;margin:0 auto" class="table">
							<thead>
								<tr>
									<th style="width:70%">
										<img src="<?php echo $pageURL.$path?>icons/time.png" class="parameterCheckIcon" alt=''>
									</th>
									<th>
									</th>
									<?php 
										if($admin){
									?>
											<th>
											</th>
									<?php 
										}
									?>
								</tr>
							</thead>
							<tbody>
							<?php
								for($i=0;$i<count($outliersH);$i++){
							?>
									<tr>
										<td>
											<?php echo date($dateFormat,$outliersH[$i][0])?><br><?php echo date($timeFormat,$outliersH[$i][0])?>
										</td>
										<td>
											<?php echo $outliersH[$i][1]?> %
										</td>
										<?php 
											if($admin){
										?>
												<td>
													<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$outliersH[$i][0]);?>)">
												</td>
										<?php 
											}
										?>
									</tr>
							<?php
								}
							?>
							</tbody>
						</table>
					<?php
						}
						if(!isset($outliersH)){
							echo "<br><br>".lang("no outliers",'c').".";
						}
					?>
				</td>
				<td style="width:14%;vertical-align:top">
					<br><br>
					<img src="<?php echo $pageURL.$path?>icons/pressure.png" class="parameterCheckIcon">
					<?php 
						if(isset($outliersP)){
					?>
						<table style="width:98%;margin:0 auto" class="table">
							<thead>
								<tr>
									<th style="width:70%">
										<img src="<?php echo $pageURL.$path?>icons/time.png" class="parameterCheckIcon" alt=''>
									</th>
									<th>
									</th>
									<?php 
										if($admin){
									?>
											<th>
											</th>
									<?php 
										}
									?>
								</tr>
							</thead>
							<tbody>
							<?php
								for($i=0;$i<count($outliersP);$i++){
							?>
									<tr>
										<td>
											<?php echo date($dateFormat,$outliersP[$i][0])?><br><?php echo date($timeFormat,$outliersP[$i][0])?>
										</td>
										<td>
											<?php echo $outliersP[$i][1]?> <?php echo $dataPressUnits?>
										</td>
										<?php 
											if($admin){
										?>
												<td>
													<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$outliersP[$i][0]);?>)">
												</td>
										<?php 
											}
										?>
									</tr>
							<?php
								}
							?>
							</tbody>
						</table>
					<?php
						}
						if(!isset($outliersP)){
							echo "<br><br>".lang("no outliers",'c').".";
						}
					?>
				</td>
				<td style="width:14%;vertical-align:top">
					<br><br>
					<img src="<?php echo $pageURL.$path?>icons/rain.png" class="parameterCheckIcon">
					<?php 
						if(isset($outliersR)){
					?>
						<table style="width:98%;margin:0 auto" class="table">
							<thead>
								<tr>
									<th style="width:70%">
										<img src="<?php echo $pageURL.$path?>icons/time.png" class="parameterCheckIcon" alt=''>
									</th>
									<th>
									</th>
									<?php 
										if($admin){
									?>
											<th>
											</th>
									<?php 
										}
									?>
								</tr>
							</thead>
							<tbody>
							<?php
								for($i=0;$i<count($outliersR);$i++){
							?>
									<tr>
										<td>
											<?php echo date($dateFormat,$outliersR[$i][0])?><br><?php echo date($timeFormat,$outliersR[$i][0])?>
										</td>
										<td>
											<?php echo $outliersR[$i][1]?> <?php echo $dataRainUnits?>
										</td>
										<?php 
											if($admin){
										?>
												<td>
													<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$outliersR[$i][0]);?>)">
												</td>
										<?php 
											}
										?>
									</tr>
							<?php
								}
							?>
							</tbody>
						</table>
					<?php
						}
						if(!isset($outliersW)){
							echo "<br><br>".lang("no outliers",'c').".";
						}
					?>
				</td>
				<td style="width:14%;vertical-align:top">
					<br><br>
					<img src="<?php echo $pageURL.$path?>icons/wind.png" class="parameterCheckIcon">
					<?php 
						if(isset($outliersW)){
					?>
						<table style="width:98%;margin:0 auto" class="table">
							<thead>
								<tr>
									<th style="width:70%">
										<img src="<?php echo $pageURL.$path?>icons/time.png" class="parameterCheckIcon" alt=''>
									</th>
									<th>
									</th>
									<?php 
										if($admin){
									?>
											<th>
											</th>
									<?php 
										}
									?>
								</tr>
							</thead>
							<tbody>
							<?php
								for($i=0;$i<count($outliersW);$i++){
							?>
									<tr>
										<td>
											<?php echo date($dateFormat,$outliersW[$i][0])?><br><?php echo date($timeFormat,$outliersW[$i][0])?>
										</td>
										<td>
											<?php echo $outliersW[$i][1]?> <?php echo $dataWindUnits?>
										</td>
										<?php 
											if($admin){
										?>
												<td>
													<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$outliersW[$i][0]);?>)">
												</td>
										<?php 
											}
										?>
									</tr>
							<?php
								}
							?>
							</tbody>
						</table>
					<?php
						}
						if(!isset($outliersW)){
							echo "<br><br>".lang("no outliers",'c').".";
						}
					?>
				</td>
				<td style="width:14%;vertical-align:top">
					<br><br>
					<img src="<?php echo $pageURL.$path?>icons/gust.png" class="parameterCheckIcon">
					<?php 
						if(isset($outliersG)){
					?>
						<table style="width:98%;margin:0 auto" class="table">
							<thead>
								<tr>
									<th style="width:70%">
										<img src="<?php echo $pageURL.$path?>icons/time.png" class="parameterCheckIcon" alt=''>
									</th>
									<th>
									</th>
									<?php 
										if($admin){
									?>
											<th>
											</th>
									<?php 
										}
									?>
								</tr>
							</thead>
							<tbody>
							<?php
								for($i=0;$i<count($outliersG);$i++){
							?>
									<tr>
										<td>
											<?php echo date($dateFormat,$outliersG[$i][0])?><br><?php echo date($timeFormat,$outliersG[$i][0])?>
										</td>
										<td>
											<?php echo $outliersG[$i][1]?> <?php echo $dataWindUnits?>
										</td>
										<?php 
											if($admin){
										?>
												<td>
													<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$outliersG[$i][0]);?>)">
												</td>
										<?php 
											}
										?>
									</tr>
							<?php
								}
							?>
							</tbody>
						</table>
					<?php
						}
						if(!isset($outliersG)){
							echo "<br><br>".lang("no outliers",'c').".";
						}
					?>
				</td>
			</tr>
		</table>
		<br><br>
		<h3><?php echo lang('nonsense values','c')?></h3>
		<br><br>
		<?php 
			if(isset($nonSense)){
		?>
				<table style="width:98%;margin:0 auto">
					<thead>
						<tr>
							<th>
								<img src="<?php echo $pageURL.$path?>icons/time.png" class="parameterCheckIcon" alt=''>
							</th>
							<th>
							</th>
							<th>
							</th>
							<?php 
								if($admin){
							?>
									<th>
									</th>
							<?php 
								}
							?>
						</tr>
					</thead>
					<tbody>
					<?php
						for($i=0;$i<count($nonSense);$i++){
					?>
							<tr>
								<td>
									<?php echo date($dateFormat,$nonSense[$i][0])?>
								</td>
								<td>
									<?php echo number_format($nonSense[$i][2],2,".","")?>
								</td>
								<td>
									<?php echo $nonSense[$i][1]?>
								</td>
								<?php 
									if($admin){
								?>
										<td>
											<img src="icons/edit.png" class="editIcon" onclick="editSpike(<?php echo date("Y,m,d",$nonSense[$i][0]);?>)">
										</td>
								<?php 
									}
								?>
							</tr>
					<?php
						}
					?>
					</tbody>
				</table>
		<?php
			}
			if(!isset($nonSense)){
				echo "<br><br>".lang('no nonsense values','c').".";
			}
		?>
		<br><br>
	</div>
	<a href="" id="gotop" style="display: none;">
		<input type="button" class="button2" value="<?php echo lang('gotop','c')?>">
	</a>
	<script>
		$(".table").tablesorter();
		Highcharts.setOptions({
			global: {
				useUTC: true
			}
		});
		$('#dataCheckGraph').highcharts({
			chart: {
				type: 'spline',
				zoomType: 'xy',
				alignTicks: false,
				backgroundColor: null,
			},
			title: {
				text: '',
				style: {
					color: "#fff",
				}
			},
			xAxis: {
				type: 'datetime',
				title: {
					text: ''
				},
				min: Date.UTC(<?php echo date("Y",$firstTimestamp).",".(date("m",$firstTimestamp)-1).date(",d,H,i",$firstTimestamp)?>),
				max: Date.UTC(<?php echo date("Y",$lastTimestamp).",".(date("m",$lastTimestamp)-1).date(",d,H,i",$lastTimestamp)?>),
				plotBands: [
					<?php
						for($i=0;$i<count($gaps);$i++){
					?>
							{
								from: Date.UTC(<?php echo date("Y",$gaps[$i][0]).",".(date("m",$gaps[$i][0])-1).date(",d,H,i",$gaps[$i][0])?>),
								to: Date.UTC(<?php echo date("Y",$gaps[$i][1]).",".(date("m",$gaps[$i][1])-1).date(",d,H,i",$gaps[$i][1])?>),
								color: '#cccccc',
							},
					<?php
						}
					?>
				],
				labels: {
					style: {
						color: '#fff',
					}
				},
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
			},
			yAxis: {
				title: {
					text: ''
				},
				labels: {
					enabled: false
				},
				minorGridLineColor: null,
				tickColor: null,
				lineColor: null,
			},
			tooltip: {
				headerFormat: '<b>{series.name}</b><br>',
				formatter: function () {
					dateX = Highcharts.dateFormat('%e %b %Y %H:%M', new Date(this.x));
					return '<b>' + dateX + '</b>';
				}
			},
			legend:{
				enabled: true,
				itemStyle: {
					color: '#fff'
				},
				itemHoverStyle: {
					color: '#dddddd'
				},
				itemHiddenStyle: {
					color: '#999999'
				},
			},
			plotOptions: {
				spline: {
					marker: {
						enabled: true
					}
				}
			},
			
			series: [
				{
					name: '<?php echo lang('gaps','c')?>',
					color: '#ffffff',
					data: [
						<?php
							for($i=0;$i<count($gaps);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$gaps[$i][0]).",".(date("m",$gaps[$i][0])-1).date(",d,H,i",$gaps[$i][0])?>),1],
								[Date.UTC(<?php echo date("Y",$gaps[$i][1]).",".(date("m",$gaps[$i][1])-1).date(",d,H,i",$gaps[$i][1])?>),1],
								[Date.UTC(<?php echo date("Y",$gaps[$i][1]).",".(date("m",$gaps[$i][1])-1).date(",d,H,i",$gaps[$i][1])?>)+1,null],
						<?php
							}
						?>
					]							
				},
				{
					name: '<?php echo lang('temperature','c')." ".lang('spikes','l')?>',
					color: '#ff0000',
					data: [
						<?php
							for($i=0;$i<count($spikesT);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$spikesT[$i][0]).",".(date("m",$spikesT[$i][0])-1).date(",d,H,i",$spikesT[$i][0])?>),1.2],
								[Date.UTC(<?php echo date("Y",$spikesT[$i][0]).",".(date("m",$spikesT[$i][0])-1).date(",d,H,i",$spikesT[$i][0])?>)+1,null],
						<?php
							}
						?>
					]							
				},
				{
					name: '<?php echo lang('apparent temperature','c')." ".lang('spikes','l')?>',
					color: '#ff99b3',
					data: [
						<?php
							for($i=0;$i<count($spikesA);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$spikesA[$i][0]).",".(date("m",$spikesA[$i][0])-1).date(",d,H,i",$spikesA[$i][0])?>),1.4],
								[Date.UTC(<?php echo date("Y",$spikesA[$i][0]).",".(date("m",$spikesA[$i][0])-1).date(",d,H,i",$spikesA[$i][0])?>)+1,null],
						<?php
							}
						?>
					]							
				},
				{
					name: '<?php echo lang('humidity','c')." ".lang('spikes','l')?>',
					color: '#36d900',
					data: [
						<?php
							for($i=0;$i<count($spikesH);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$spikesH[$i][0]).",".(date("m",$spikesH[$i][0])-1).date(",d,H,i",$spikesH[$i][0])?>),1.6],
								[Date.UTC(<?php echo date("Y",$spikesH[$i][0]).",".(date("m",$spikesH[$i][0])-1).date(",d,H,i",$spikesH[$i][0])?>)+1,null],
						<?php
							}
						?>
					]							
				},
				{
					name: '<?php echo lang('pressure','c')." ".lang('spikes','l')?>',
					color: '#ff9326',
					data: [
						<?php
							for($i=0;$i<count($spikesP);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$spikesP[$i][0]).",".(date("m",$spikesP[$i][0])-1).date(",d,H,i",$spikesP[$i][0])?>),1.8],
								[Date.UTC(<?php echo date("Y",$spikesP[$i][0]).",".(date("m",$spikesP[$i][0])-1).date(",d,H,i",$spikesP[$i][0])?>)+1,null],
						<?php
							}
						?>
					]							
				},
				{
					name: '<?php echo lang('precipitation','c')." ".lang('spikes','l')?>',
					color: '#4ca6ff',
					data: [
						<?php
							for($i=0;$i<count($spikesP);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$spikesR[$i][0]).",".(date("m",$spikesR[$i][0])-1).date(",d,H,i",$spikesR[$i][0])?>),2],
								[Date.UTC(<?php echo date("Y",$spikesR[$i][0]).",".(date("m",$spikesR[$i][0])-1).date(",d,H,i",$spikesR[$i][0])?>)+1,null],
						<?php
							}
						?>
					]							
				},
			]
		});
		$('#dataCheckGraphTA').highcharts({
			chart: {
				type: 'scatter',
				zoomType: 'xy',
				alignTicks: false,
				backgroundColor: null,
			},
			title: {
				text: '<div style="text-align:center"><img src="<?php echo $pageURL.$path?>icons/temp.png" class="parameterCheckIcon"> <img src="<?php echo $pageURL.$path?>icons/apparent.png" class="parameterCheckIcon"></div>',
				useHTML: true,
				style: {
					color: "#fff",
				}
			},
			xAxis: {
				type: 'datetime',
				title: {
					text: ''
				},
				min: Date.UTC(<?php echo date("Y",$firstTimestamp).",".(date("m",$firstTimestamp)-1).date(",d,H,i",$firstTimestamp)?>),
				max: Date.UTC(<?php echo date("Y",$lastTimestamp).",".(date("m",$lastTimestamp)-1).date(",d,H,i",$lastTimestamp)?>),
				labels: {
					style: {
						color: '#fff',
					}
				},
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
			},
			yAxis: {
				title: {
					text: '°<?php echo $dataTempUnits?>',
					style: {
						color: '#fff',
					}
				},
				labels: {
					style: {
						color: '#fff',
					}
				},
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
			},
			tooltip: {
				headerFormat: '<b>{series.name}</b><br>',
				formatter: function () {
					dateX = Highcharts.dateFormat('%e %b %Y %H:%M', new Date(this.x));
					return '<b>' + dateX + '</b>: ' + this.y;
				}
			},
			legend:{
				enabled: true,
				itemStyle: {
					color: '#fff'
				},
				itemHoverStyle: {
					color: '#dddddd'
				},
				itemHiddenStyle: {
					color: '#999999'
				},
			},
			plotOptions: {
				spline: {
					marker: {
						enabled: true
					}
				}
			},	
			series: [
				{
					name: '<?php echo lang('temperature','c')?>',
					color: '#ffffff',
					data: [
						<?php
							for($i=0;$i<count($outliersT);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$outliersT[$i][0]).",".(date("m",$outliersT[$i][0])-1).date(",d,H,i",$outliersT[$i][0])?>),<?php echo $outliersT[$i][1]?>],
						<?php
							}
						?>
					]							
				},
				{
					name: '<?php echo lang('apparent temperature','c')?>',
					color: '#cccccc',
					data: [
						<?php
							for($i=0;$i<count($outliersA);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$outliersA[$i][0]).",".(date("m",$outliersA[$i][0])-1).date(",d,H,i",$outliersA[$i][0])?>),<?php echo $outliersA[$i][1]?>],
						<?php
							}
						?>
					]							
				},
			]
		});
		$('#dataCheckGraphH').highcharts({
			chart: {
				type: 'scatter',
				zoomType: 'xy',
				alignTicks: false,
				backgroundColor: null,
			},
			title: {
				text: '<div style="text-align:center"><br><img src="<?php echo $pageURL.$path?>icons/humidity.png" class="parameterCheckIcon"></div>',
				useHTML: true,
				style: {
					color: "#fff",
				}
			},
			xAxis: {
				type: 'datetime',
				title: {
					text: ''
				},
				min: Date.UTC(<?php echo date("Y",$firstTimestamp).",".(date("m",$firstTimestamp)-1).date(",d,H,i",$firstTimestamp)?>),
				max: Date.UTC(<?php echo date("Y",$lastTimestamp).",".(date("m",$lastTimestamp)-1).date(",d,H,i",$lastTimestamp)?>),
				labels: {
					style: {
						color: '#fff',
					}
				},
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
			},
			yAxis: {
				title: {
					text: '%',
					style: {
						color: '#fff',
					}
				},
				labels: {
					style: {
						color: '#fff',
					}
				},
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
				min: 0,
				max: 100
			},
			tooltip: {
				headerFormat: '<b>{series.name}</b><br>',
				formatter: function () {
					dateX = Highcharts.dateFormat('%e %b %Y %H:%M', new Date(this.x));
					return '<b>' + dateX + '</b>: ' + this.y;
				}
			},
			legend:{
				enabled: true,
				itemStyle: {
					color: '#fff'
				},
				itemHoverStyle: {
					color: '#dddddd'
				},
				itemHiddenStyle: {
					color: '#999999'
				},
			},
			plotOptions: {
				spline: {
					marker: {
						enabled: true
					}
				}
			},	
			series: [
				{
					name: '<?php echo lang('humidity','c')?>',
					color: '#ffffff',
					data: [
						<?php
							for($i=0;$i<count($outliersH);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$outliersH[$i][0]).",".(date("m",$outliersH[$i][0])-1).date(",d,H,i",$outliersH[$i][0])?>),<?php echo $outliersH[$i][1]?>],
						<?php
							}
						?>
					]							
				},
			]
		});
		$('#dataCheckGraphP').highcharts({
			chart: {
				type: 'scatter',
				zoomType: 'xy',
				alignTicks: false,
				backgroundColor: null,
			},
			title: {
				text: '<div style="text-align:center"><br><img src="<?php echo $pageURL.$path?>icons/pressure.png" class="parameterCheckIcon"></div>',
				useHTML: true,
				style: {
					color: "#fff",
				}
			},
			xAxis: {
				type: 'datetime',
				title: {
					text: ''
				},
				min: Date.UTC(<?php echo date("Y",$firstTimestamp).",".(date("m",$firstTimestamp)-1).date(",d,H,i",$firstTimestamp)?>),
				max: Date.UTC(<?php echo date("Y",$lastTimestamp).",".(date("m",$lastTimestamp)-1).date(",d,H,i",$lastTimestamp)?>),
				labels: {
					style: {
						color: '#fff',
					}
				},
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
			},
			yAxis: {
				title: {
					text: '<?php echo $dataPressUnits?>',
					style: {
						color: '#fff',
					}
				},
				labels: {
					style: {
						color: '#fff',
					}
				},
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
			},
			tooltip: {
				headerFormat: '<b>{series.name}</b><br>',
				formatter: function () {
					dateX = Highcharts.dateFormat('%e %b %Y %H:%M', new Date(this.x));
					return '<b>' + dateX + '</b>: ' + this.y;
				}
			},
			legend:{
				enabled: true,
				itemStyle: {
					color: '#fff'
				},
				itemHoverStyle: {
					color: '#dddddd'
				},
				itemHiddenStyle: {
					color: '#999999'
				},
			},
			plotOptions: {
				spline: {
					marker: {
						enabled: true
					}
				}
			},	
			series: [
				{
					name: '<?php echo lang('pressure','c')?>',
					color: '#ffffff',
					data: [
						<?php
							for($i=0;$i<count($outliersP);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$outliersP[$i][0]).",".(date("m",$outliersP[$i][0])-1).date(",d,H,i",$outliersP[$i][0])?>),<?php echo $outliersP[$i][1]?>],
						<?php
							}
						?>
					]							
				}
			]
		});
		$('#dataCheckGraphR').highcharts({
			chart: {
				type: 'scatter',
				zoomType: 'xy',
				alignTicks: false,
				backgroundColor: null,
			},
			title: {
				text: '<div style="text-align:center"><br><img src="<?php echo $pageURL.$path?>icons/rain.png" class="parameterCheckIcon"></div>',
				useHTML: true,
				style: {
					color: "#fff",
				}
			},
			xAxis: {
				type: 'datetime',
				title: {
					text: ''
				},
				min: Date.UTC(<?php echo date("Y",$firstTimestamp).",".(date("m",$firstTimestamp)-1).date(",d,H,i",$firstTimestamp)?>),
				max: Date.UTC(<?php echo date("Y",$lastTimestamp).",".(date("m",$lastTimestamp)-1).date(",d,H,i",$lastTimestamp)?>),
				labels: {
					style: {
						color: '#fff',
					}
				},
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
			},
			yAxis: {
				title: {
					text: '<?php echo $dataRainUnits?>',
					style: {
						color: '#fff',
					}
				},
				labels: {
					style: {
						color: '#fff',
					}
				},
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
				min: 0,
			},
			tooltip: {
				headerFormat: '<b>{series.name}</b><br>',
				formatter: function () {
					dateX = Highcharts.dateFormat('%e %b %Y %H:%M', new Date(this.x));
					return '<b>' + dateX + '</b>: ' + this.y;
				}
			},
			legend:{
				enabled: true,
				itemStyle: {
					color: '#fff'
				},
				itemHoverStyle: {
					color: '#dddddd'
				},
				itemHiddenStyle: {
					color: '#999999'
				},
			},
			plotOptions: {
				spline: {
					marker: {
						enabled: true
					}
				}
			},	
			series: [
				{
					name: '<?php echo lang('precipitation','c')?>',
					color: '#ffffff',
					data: [
						<?php
							for($i=0;$i<count($outliersR);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$outliersR[$i][0]).",".(date("m",$outliersR[$i][0])-1).date(",d,H,i",$outliersR[$i][0])?>),<?php echo $outliersR[$i][1]?>],
						<?php
							}
						?>
					]							
				}
			]
		});
		$('#dataCheckGraphWG').highcharts({
			chart: {
				type: 'scatter',
				zoomType: 'xy',
				alignTicks: false,
				backgroundColor: null,
			},
			title: {
				text: '<div style="text-align:center"><br><img src="<?php echo $pageURL.$path?>icons/wind.png" class="parameterCheckIcon"> <img src="<?php echo $pageURL.$path?>icons/gust.png" class="parameterCheckIcon"></div>',
				useHTML: true,
				style: {
					color: "#fff",
				}
			},
			xAxis: {
				type: 'datetime',
				title: {
					text: ''
				},
				min: Date.UTC(<?php echo date("Y",$firstTimestamp).",".(date("m",$firstTimestamp)-1).date(",d,H,i",$firstTimestamp)?>),
				max: Date.UTC(<?php echo date("Y",$lastTimestamp).",".(date("m",$lastTimestamp)-1).date(",d,H,i",$lastTimestamp)?>),
				labels: {
					style: {
						color: '#fff',
					}
				},
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
			},
			yAxis: {
				title: {
					text: '<?php echo $dataWindUnits?>',
					style: {
						color: '#fff',
					}
				},
				labels: {
					style: {
						color: '#fff',
					}
				},
				min: 0,
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
			},
			tooltip: {
				headerFormat: '<b>{series.name}</b><br>',
				formatter: function () {
					dateX = Highcharts.dateFormat('%e %b %Y %H:%M', new Date(this.x));
					return '<b>' + dateX + '</b>: ' + this.y;
				}
			},
			legend:{
				enabled: true,
				itemStyle: {
					color: '#fff'
				},
				itemHoverStyle: {
					color: '#dddddd'
				},
				itemHiddenStyle: {
					color: '#999999'
				},
			},
			plotOptions: {
				spline: {
					marker: {
						enabled: true
					}
				}
			},	
			series: [
				{
					name: '<?php echo lang('wind speed','c')?>',
					color: '#ffffff',
					data: [
						<?php
							for($i=0;$i<count($outliersW);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$outliersW[$i][0]).",".(date("m",$outliersW[$i][0])-1).date(",d,H,i",$outliersW[$i][0])?>),<?php echo $outliersW[$i][1]?>],
						<?php
							}
						?>
					]							
				},
				{
					name: '<?php echo lang('wind gust','c')?>',
					color: '#cccccc',
					data: [
						<?php
							for($i=0;$i<count($outliersG);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$outliersG[$i][0]).",".(date("m",$outliersG[$i][0])-1).date(",d,H,i",$outliersG[$i][0])?>),<?php echo $outliersG[$i][1]?>],
						<?php
							}
						?>
					]							
				},
			]
		});
		$('#dataCheckGraphNonsense').highcharts({
			chart: {
				type: 'scatter',
				zoomType: 'xy',
				alignTicks: false,
				backgroundColor: null,
			},
			title: {
				text: '',
				style: {
					color: "#fff",
				}
			},
			xAxis: {
				type: 'datetime',
				title: {
					text: ''
				},
				min: Date.UTC(<?php echo date("Y",$firstTimestamp).",".(date("m",$firstTimestamp)-1).date(",d,H,i",$firstTimestamp)?>),
				max: Date.UTC(<?php echo date("Y",$lastTimestamp).",".(date("m",$lastTimestamp)-1).date(",d,H,i",$lastTimestamp)?>),
				labels: {
					style: {
						color: '#fff',
					}
				},
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
			},
			yAxis: {
				title: {
					text: '<?php echo $dataWindUnits?>',
					style: {
						color: '#fff',
					}
				},
				labels: {
					style: {
						color: '#fff',
					}
				},
				min: 0,
				minorGridLineColor: '#fff',
				tickColor: '#fff',
				lineColor: '#fff',
			},
			tooltip: {
				headerFormat: '<b>{series.name}</b><br>',
				formatter: function () {
					dateX = Highcharts.dateFormat('%e %b %Y %H:%M', new Date(this.x));
					return '<b>' + dateX + '</b>: ' + this.y;
				}
			},
			legend:{
				enabled: true,
				itemStyle: {
					color: '#fff'
				},
				itemHoverStyle: {
					color: '#dddddd'
				},
				itemHiddenStyle: {
					color: '#999999'
				},
			},
			plotOptions: {
				spline: {
					marker: {
						enabled: true
					}
				}
			},	
			series: [
				{
					name: '<?php echo lang('nonsense values','c')?>',
					color: '#ffffff',
					data: [
						<?php
							for($i=0;$i<count($nonSense);$i++){
						?>
								[Date.UTC(<?php echo date("Y",$nonSense[$i][0]).",".(date("m",$nonSense[$i][0])-1).date(",d,H,i",$nonSense[$i][0])?>),<?php echo $nonSense[$i][2]?>],
						<?php
							}
						?>
					]							
				}
			]
		});
	</script>
	<script>
		function editSpike(y,m,d){
			window.open("../../admin/tableEdit.php?d=" + d + "&m=" + m + "&y=" + y, '_blank');
		}
	</script>
	<script>
		$(function () {
			$("#gotop").scrollToTop();
			$("#scrollSummary").click(function(){
				$('html, body').animate({
					scrollTop: $("#titleSummary").offset().top
				}, 1000);
			});
			$("#scrollGraph").click(function(){
				$('html, body').animate({
					scrollTop: $("#titleGraphs").offset().top
				}, 1000);
			});
			$("#scrollTable").click(function(){
				$('html, body').animate({
					scrollTop: $("#titleTables").offset().top
				}, 1000);
			});				
		});
	</script>